#extract from NONMEM table file and format for time to event
BEGIN {
id="ID";time="TIME";trt="TRT";amt="AMT";rate="RATE";addl="ADDL";
ii="II";wt="WT";dvid="DVID";dv="DV";mdv="MDV";cp="CP";
pca="PCA";inr="INR";cl="CL";v="V";tabs="TABS";tlag="TLAG"; f1="F1"
pca0="PCA0";emax="EMAX";c50="C50";teq="TEQ"; rep="REP"
HASH="#"
MISSING="."
# Start Process command line arguments...
isall=(index(toupper(ALL),"A")==1)
DELTA=DELTA+0
STARTDVID=STARTDVID+0
FS=IFS # input file separator
# ...End Process command line arguments
print mkrec() # headings
lastid=-9999
} # Begin

/TABLE/ || /ID/ { next } # skip header rows

{ # process records
   _id_=$1
   if (lastid != _id_) {
      if (lastid>=0) printrecs()
      lastid=_id_
      nrec=0
      hasdrop=0
   }
   if (hasdrop) next
   splitrec1()
   if (dvid==0 || (dvid==3 && (isall || mdv==0))) addrec() # dose or (all || event record)
   if (dvid==3 && mdv==0) hasdrop=1
#   if (id>47) exit
} #process records

END {
   printrecs()
} # End

function printrecs(    i,saverec) {
   saverec=$0
   FS=","
   for (i=1; i<=nrec; i++) {
      $0=REC[i]
      splitrec1()
      if (i<nrec) { # event is the only allowed observation type
         mdv=1
         dv=0
      } else if (DELTA && dvid==3 && dv==1) { 
         timeorg=time
         time=time-DELTA # insert an interval censoring record DELTA previously
         if (time<0) time=0
         if (STARTDVID) {
            # Use this record to signal start of event interval with STARTDVID
            dvid=STARTDVID # use STARTDVID for dvid
            mdv=1
            dv=0
         } else {
            # Use this record to signal a censored event observation
            mdv=0
            dv=0
         }
         print mkrec()
         time=timeorg+DELTA # make event record DELTA later
         mdv=0
         dv=1
      } else
         mdv=0
      print mkrec()
   }
   FS=IFS
   $0=saverec
} #printrecs

function addrec() {
   REC[++nrec]=mkrec()
} #addrec

function mkrec() {
rec=sprintf("%s,%s,%s,%s,%s,%s,",id,time,trt,amt,rate,addl)
rec=rec sprintf("%s,%s,%s,%s,%s,%s,",ii,wt,dvid,dv,mdv,rep)
rec=rec sprintf("%s,%s,%s,%s,%s,%s,%s,%s,",cp,pca,inr,cl,v,tabs,tlag,f1)
rec=rec sprintf("%s,%s,%s,%s",pca0,emax,c50,teq)
return rec
} #mkrec

function splitrec1() {
id=$1+0;time=$2+0;trt=$3+0;amt=$4+0;rate=$5+0;addl=$6+0;
ii=$7+0;wt=$8+0;dvid=$9+0;dv=$10+0;mdv=$11+0;;rep=$12+0;
cp=$13+0; pca=$14+0;inr=$15+0;cl=$16+0;v=$17+0;tabs=$18+0;tlag=$19+0;f1=$20+0
pca0=$21+0;emax=$22+0;c50=$23+0;teq=$24+0
} #splitrec1

