$PROB Estimate time to event
$INPUT ID TIME TRT 
AMT RATE ADDL II
WT DVID DV MDV REP=DROP
CPX=DROP PCAX=DROP INRX=DROP ; inidividual predictions of CP, PCA, INR
ICL IV ITABS ITLAG IF1; individual PK parameters used for simulation
IPCA0 IEMAX IC50 ITEQ ; individual PD parameters used for simulation 
$DATA ..\warf_INR_sim.reg\1.csv  IGNORE=@
IGNORE (DVID.EQ.1) ; Conc
IGNORE (DVID.EQ.2) ; PCA

$ESTIM MAX=9990 SIG=3 NOABORT ;PRINT=1
METHOD=ZERO LIKE
$COV

;O'Reilly RA, Aggeler PM. Studies on coumarin anticoagulant drugs
;Initiation of warfarin therapy without a loading dose.
;Circulation 1968;38:169-177
;
;O'Reilly RA, Aggeler PM, Leong LS. Studies of the coumarin anticoagulant
;drugs: The pharmacodynamics of warfarin in man.
;Journal of Clinical Investigation 1963;42(10):1542-1551

;Event hazard
$THETA
(0,0.1,) ; POP_HBASE 1/y baseline hazard (major haemorrhage) (0.1)
(0,0.5,) ; POP_BTAINR hazard ratio increase with INR (0.5)
$OMEGA 0 FIX ; PPV_HBASE (dummy to keep NM-TRAN happy)

$SUBR ADVAN6 TOL=3
$MODEL
   COMP=CENTRAL
   COMP=PCA
   COMP=HAZEVT

$PK

   IF (NEWIND.EQ.0) LN2=LOG(2)

   CL=ICL ;FSZCL*POP_CL*EXP(PPV_CL)*24 ; L/h -> L/d
   V=IV ;FSZV*POP_V*EXP(PPV_V)
   TABS=ITABS; POP_TABS*EXP(PPV_TABS)/24 ; h -> d
   TLAG=ITLAG; POP_LAG*EXP(PPV_LAG)/24 ; h -> d
   F1=IF1

   PCA0=IPCA0; POP_PCA0*EXP(PPV_PCA0)
   EMAX=IEMAX; POP_EMAX*EXP(PPV_EMAX)
   C50=IC50; POP_C50*EXP(PPV_C50)
   TEQ=ITEQ; POP_TEQ*EXP(PPV_TEQ)/24 ; h -> d

   HBASE=POP_HBASE/365 *EXP(PPV_HBASE) ; 1/y -> 1/d
   BTAINR=POP_BTAINR 

   D1=TABS
   ALAG1=TLAG
   S1=V
   A_0(2)=PCA0
   KPCA=LN2/TEQ
   RPCA=PCA0*KPCA
   
$DES
   DCP=A(1)/V
   DPCA=A(2)
   DINR=PCA0/DPCA
   PD=1+EMAX*DCP/(C50+DCP)
   DHAZ=HBASE*EXP(BTAINR*DINR)

   DADT(1)= - CL*DCP ; warfarin conc
   DADT(2)=RPCA*PD - KPCA*DPCA ; turnover for PCA
   DADT(3)=DHAZ

$ERROR

   CP=A(1)/V
   PCA=A(2)
   INR=PCA0/PCA
   CUMEVT=A(3)
   HAZ=HBASE*EXP(BTAINR*INR)

   ; Prob of not having event up to this time
   SEVTT=EXP(-CUMEVT) ; Survivor function (t)

   IF (DVID.EQ.3.AND.DV.EQ.0) THEN 
      Y=SEVTT ; likelihood of censored event
   ENDIF
   IF (DVID.EQ.3.AND.DV.EQ.1) THEN 
      Y=SEVTT * HAZ ; likelihood of event at exact time
   ENDIF

