$SIZES NO=1200 LIM6=1200 ; NO AND LIM6 MUST BE >=MAX NUMBER OF OBSERVATIONS RECS/SUBJECT
$PROB SIMULATE TIME TO EVENT
$DATA ..\data.csv
$INPUT ID TIME TRT AMT RATE ADDL II WT DVID DV MDV REPX=DROP
$SIM (20210101) (20210102 UNIFORM) (20210103 UNIFORM)
(20210104 UNIFORM) (20210105 UNIFORM) ONLYSIM NSUB=2
REWIND ; NM74 OR LATER
;O'REILLY RA, AGGELER PM. STUDIES ON COUMARIN ANTICOAGULANT DRUGS. 
;INITIATION OF WARFARIN THERAPY WITHOUT A LOADING DOSE. 
;CIRCULATION. 1968;38:169-77.

;O'REILLY RA, AGGELER PM, LEONG LS. STUDIES OF THE COUMARIN ANTICOAGULANT DRUGS:
;THE PHARMACODYNAMICS OF WARFARIN IN MAN. 
;J CLIN INVEST. 1963;42(10):1542-51.

;HOLFORD NHG. THE VISUAL PREDICTIVE CHECK  SUPERIORITY TO STANDARD DIAGNOSTIC
;(RORSCHACH) PLOTS 
;[WWW.PAGE-MEETING.ORG/?ABSTRACT=738]. PAGE. 2005;14

;EVENT HAZARD
$THETA
0.1 ; POP_HBASE 1/Y BASELINE HAZARD (MAJOR HAEMORRHAGE)
0.2 ; POP_HDROP 1/Y BASELINE HAZARD (DROPOUT)
0 FIX ; POP_BTATRT HAZARD RATIO INCREASE PER 1 MG/D WARFARIN (0.4)
0 FIX ; POP_BTAPCA HAZARD RATIO INCREASE WITH 100% DECREASE IN PCA (2.0)
0.5 ; POP_BTAINR HAZARD RATIO INCREASE WITH INR (0.5)

;WARFARIN PKPD

$THETA
(0.01,0.128,1) ; POP_CL L/H/70KG
(0.01,8.11,20) ; POP_V L/70KG
(0.01,1.46,24) ; POP_TABS H
(0.,0.998,24) ; POP_LAG H
(0.01,96.3,200) ; POP_PCA0
-1. FIX ; POP_EMAX
(0.01,1.24,10) ; POP_C50 MG/L
(0.01,12.9,100) ; POP_TEQ H

$OMEGA
0.0645 ; PPV_CL
0.0183 ; PPV_V
0.619 ; PPV_TABS
0.278 ; PPV_LAG
0.001 ; PPV_PCA0
0 FIX ; PPV_EMAX
0.191 ; PPV_C50
0.0116 ; PPV_TEQ
0.01   ; PPV_HBASE

$SIGMA
0.00693 ; RUV_CV
0.0818 ; RUV_SD MG/L
16. ; RUV_PCA 

$THETA
70 ; TBWKG_STD KG 
$OMEGA
0.01 ; PPV_TBWKG

$SUBR ADVAN6 TOL=3
$MODEL
   COMP=CENTRAL
   COMP=PCA
   COMP=HAZEVT
   COMP=HAZDRP
$PK

   IF (NEWIND.LE.1) THEN
      LN2=LOG(2)
      HASEVT=0 ; NOT HAD EVENT
      HASDRP=0 ; NOT DROPPED OUT
      SEVTZ=1 ; SURVIVOR FUNCTION AT TIME=0
      DOSE=0
   ENDIF
   IF (ICALL.EQ.4) THEN
      IF (NEWIND.LE.1) THEN ; FIRST RECORD
         CALL RANDOM(2,R)
         UEVT=R ; UNIFORM RANDOM NUMBER FOR EVENT
         CALL RANDOM(3,R)
         UTRT=R ; UNIFORM RANDOM NUMBER FOR TREATMENT
         CALL RANDOM(4,R)
         UDRP=R ; UNIFORM RANDOM NUMBER FOR DROPOUT
         IF (UTRT.LT.0.25) THEN ; PLACEBO
            RATE=0
            ADDL=0
            II=0
            SF1=0
            STRT=0
         ELSE
            IF (UTRT.LT.0.5) THEN ; DOSE 1
               SF1=2.5 
               STRT=1
            ELSE
               IF (UTRT.LT.0.75) THEN ; DOSE 2
                  SF1=5
                  STRT=2
               ELSE
                  SF1=10 
                  STRT=4
               ENDIF
            ENDIF
         ENDIF
         STBWKG=TBWKG_STD*EXP(PPV_TBWKG) ; SIMULATED WEIGHT
      ENDIF
      DOSE=1*SF1 ; MG
      TBWKG=STBWKG
      TRT=STRT
   ENDIF
   F1=DOSE

   FSZV=TBWKG/TBWKG_STD
   FSZCL=FSZV**0.75

   CL=FSZCL*POP_CL*EXP(PPV_CL)*24 ; L/H -> L/D
   V=FSZV*POP_V*EXP(PPV_V)
   TABS=POP_TABS*EXP(PPV_TABS)/24 ; H -> D
   TLAG=POP_LAG*EXP(PPV_LAG)/24 ; H -> D

   PCA0=POP_PCA0*EXP(PPV_PCA0)
   EMAX=POP_EMAX*EXP(PPV_EMAX)
   C50=POP_C50*EXP(PPV_C50)
   TEQ=POP_TEQ*EXP(PPV_TEQ)/24 ; H -> D

   HBASE=POP_HBASE*EXP(PPV_HBASE)/365 ; 1/Y -> 1/D
   HDROP=POP_HDROP/365 ; 1/Y -> 1/D
   BTATRT=POP_BTATRT 
   BTAPCA=POP_BTAPCA 
   BTAINR=POP_BTAINR 

   D1=TABS
   ALAG1=TLAG
   S1=V
   A_0(2)=PCA0
   KPCA=LN2/TEQ
   RPCA=PCA0*KPCA
   
$DES
   DCP=A(1)/V
   DPCA=A(2)
   DINR=PCA0/DPCA
   PD=1+EMAX*DCP/(C50+DCP)

   DADT(1)=- CL*DCP ; WARFARIN CONC
   DADT(2)=RPCA*PD - KPCA*DPCA ; TURNOVER FOR PCA
   DADT(3)=HBASE * EXP(BTATRT*TRT + BTAINR*DINR + BTAPCA*(1-DPCA/PCA0))
   DADT(4)=HDROP

$ERROR

   CP=A(1)/V
   PCA=A(2)
   CUMEVT=A(3)
   CUMDRP=A(4)

   ; PROB OF NOT HAVING EVENT UP TO THIS TIME
   SEVTT=EXP(-CUMEVT) ; SURVIVOR FUNCTION (T)

   ; PROB OF NOT HAVING DROPPED OUT TO THIS TIME
   SDRPT=EXP(-CUMDRP) ; SURVIVOR FUNCTION (T)

   IF (DVID.LE.1) THEN
      F_FLAG=0
      Y=CP*(1+RUV_CV) + RUV_SD
   ENDIF
   IF (DVID.EQ.2) THEN
      F_FLAG=0
      Y=PCA + RUV_PCA
   ENDIF
   IF (DVID.EQ.3.AND.DV.EQ.0) THEN ; CENSORED EVENT
      F_FLAG=1
      Y=SEVTT ; SURVIVOR FUNCTION
   ENDIF
   IF (DVID.EQ.3.AND.DV.EQ.1) THEN ; EVENT IN INTERVAL
      F_FLAG=1
      Y=SEVTZ - SEVTT ; LIKELIHOOD OF EVENT IN INTERVAL
   ENDIF

   IF (ICALL.EQ.4) THEN
      IF (DVID.EQ.3.AND.HASDRP.EQ.0.AND.SDRPT.LT.UDRP) THEN
         HASDRP=1
         DVX=0 ; CENSORED EVENT
         DVIX=3
         MDVX=0
      ELSE
         IF (HASDRP.EQ.0.AND.HASEVT.EQ.0) THEN
            IF (DVID.EQ.3) THEN ; CHECK FOR EVENT
               IF (SEVTT.LT.UEVT) THEN ; EVENT 
                  HASEVT=1
                  DVX=1
                  DVIX=3
                  MDVX=0
               ELSE ; DUMMY EVENT RECORD
                  DVX=0
                  DVIX=3
                  MDVX=1
               ENDIF
            ELSE ; LAST RECORD (DEFAULT FOR CENSORING) OR OTHER EVID (DOSE, OBS)
               IF (DVID.EQ.4) THEN ; LAST RECORD
                  DVX=0 ; CENSORED EVENT
                  DVIX=3
                  MDVX=0
               ELSE ; DOSE OR CONC OR PCA
                  IF (DVID.EQ.0) THEN ; DOSE
                     DVX=0
                     MDVX=1
                  ELSE ; OBSERVATION
                     DVX=Y
                     MDVX=0
                  ENDIF
                  DVIX=DVID
               ENDIF
            ENDIF
         ELSE ; AFTER DROPOUT OR AFTER EVENT SO CONVERT TO MISSING
            DVX=0
            DVIX=DVID
            MDVX=1
         ENDIF
      ENDIF
   ENDIF

   IF (DVID.EQ.3) THEN ; START NEW EVENT INTERVAL
      SEVTZ=SEVTT ; SURVIVOR FUNCTION AT START OF NEW INTERVAL
   ELSE ; SAVE RECURSIVE RANDOM VARIABLE (ONLY WORKS WITH NMVI OR LATER)
      SEVTZ=SEVTZ
   ENDIF

   INR=PCA0/PCA

   REP=IREP

$TABLE ID TIME TRT AMT RATE ADDL II TBWKG DVIX DVX MDVX REP
CP PCA INR CL V TABS TLAG F1 PCA0 EMAX C50 TEQ
NOAPPEND ONEHEADER NOPRINT FILE=warf_inr_sim_org.fit
