#simdat
BEGIN {
   id="#ID"; time="TIME"; trt="TRT"; amt="AMT"; rate="RATE"; addl="ADDL"; ii="II"; wt="WT"; dvid="DVID"; dv="DV"; mdv="MDV"; rep="REP"
   printrec() # data item header

   if (NREP=="") NREP=1 # number of replications
   if (NSUB=="") NSUB=1000 # number of subjects
   if (TLAST=="") TLAST=365 # time of last observation
   if (OBSINT=="") OBSINT=1 # interval between observations
   if (II=="") II=1 # interval between observations
   if (NCYCLE=="") NCYCLE=0 # number of cycles
   if (CYCLEINT=="") CYCLEINT=-1 # interval between cycles
   DRATE=1 # nominal dose
   nobs=TLAST/OBSINT
   isall=(index(toupper(ALL),"Y")==1)

   MISSING="."
   wt=70
   trt=1
   for (rep=1; rep<=NREP; rep++) {
      for (id=1; id<=NSUB; id++) {
         time=0; printdose()
         amt=MISSING; rate=MISSING; addl=MISSING; ii=MISSING
         for (j=1; j<=nobs+1; j++) {
            time=(j-1)*OBSINT
            if (time==CYCLEINT) {
               printdose()
               amt=MISSING; rate=MISSING; addl=MISSING; ii=MISSING
            }
            if (isall) { 
               dvid=1; printrec()  # CONC
               dvid=2; printrec() # PCA
            }
            if (j<=nobs)
               dvid=3
            else
               dvid=4 # last record
            printrec() # event
         }
      }
   }
}

function printrec() {
   printf("%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s\n",id,time,trt,amt,rate,addl,ii,wt,dvid,dv,mdv,rep)
}
function printdose() {
   if (NCYCLE<=0)
      addl=nobs*OBSINT - 1
   else
      addl=NCYCLE-1
   amt=DRATE; rate=-2; dv=MISSING; mdv=1
   ii=II
   dvid=0
   printrec()
}
