$PROB ESTIMATE TIME TO EVENT
$INPUT ID TIME TRT 
AMT=DROP RATE=DROP ADDL=DROP II=DROP WT=DROP
DVID DV MDV REP=DROP
CPX=DROP PCAX=DROP INRX=DROP ; INDIVIDUAL PREDICTIONS OF CP, PCA, INR
ICL=DROP IV=DROP ITABS=DROP ITLAG=DROP IF1=DROP ; INDIVIDUAL PK PARAMETERS USED FOR SIMULATION
IPCA0=DROP IEMAX=DROP IC50=DROP ITEQ=DROP ; INDIVIDUAL PD PARAMETERS USED FOR SIMULATION 

$DATA ..\nmsamp.dat IGNORE=@
IGNORE (DVID.EQ.1) ; CONC
IGNORE (DVID.EQ.2) ; PCA

$ESTIM MAX=9990 SIG=3 NOABORT ;PRINT=1
METHOD=ZERO LIKE
$COV

;O'REILLY RA, AGGELER PM. STUDIES ON COUMARIN ANTICOAGULANT DRUGS
;INITIATION OF WARFARIN THERAPY WITHOUT A LOADING DOSE.
;CIRCULATION 1968;38:169-177
;
;O'REILLY RA, AGGELER PM, LEONG LS. STUDIES OF THE COUMARIN ANTICOAGULANT
;DRUGS: THE PHARMACODYNAMICS OF WARFARIN IN MAN.
;JOURNAL OF CLINICAL INVESTIGATION 1963;42(10):1542-1551

;EVENT HAZARD
$THETA
(0,0.1,) ; POP_HBASE 1/Y BASELINE HAZARD (MAJOR HAEMORRHAGE)
0.001 ; POP_BTAWBL HAZARD RATIO INCREASE PER LN(YEAR)
$OMEGA 0 FIX ; PPV_HBASE (DUMMY TO KEEP NM-TRAN HAPPY)

$SUBR ADVAN6 TOL=3
$MODEL
   COMP=CUMEVT

$PK
   HBASE=THETA(1)/365 *EXP(ETA(1)) ; 1/Y -> 1/D
   BTAWBL=THETA(2)/365  ; 1/Y -> 1/D

$DES
   IF (T.GT.0) THEN
      DHAZ=HBASE *EXP(BTAWBL*LOG(T))
   ELSE
      DHAZ=0
   ENDIF
   DADT(1)=DHAZ
$ERROR

   CUMEVT=A(1)
   IF (TIME.GT.0) THEN
      HAZ=HBASE *EXP(BTAWBL*LOG(TIME))
   ELSE
      HAZ=0
   ENDIF
   ; PROB OF NOT HAVING EVENT UP TO THIS TIME
   SEVTT=EXP(-CUMEVT) ; SURVIVOR FUNCTION (T)

   IF (DVID.EQ.3.AND.DV.EQ.0) THEN 
      Y=SEVTT ; LIKELIHOOD OF CENSORED EVENT
   ENDIF
   IF (DVID.EQ.3.AND.DV.EQ.1) THEN 
      Y=SEVTT * HAZ ; LIKELIHOOD OF EVENT AT EXACT TIME
   ENDIF


