$PROB ESTIMATE TIME TO EVENT
$INPUT ID TIME TRT 
AMT RATE ADDL II
WT DVID DV MDV REP=DROP
CPX=DROP PCAX=DROP INRX=DROP ; INIDIVIDUAL PREDICTIONS OF CP, PCA, INR
ICL IV ITABS ITLAG IF1; INDIVIDUAL PK PARAMETERS USED FOR SIMULATION
IPCA0 IEMAX IC50 ITEQ ; INDIVIDUAL PD PARAMETERS USED FOR SIMULATION 
$DATA ..\nmsamp.dat IGNORE=@
IGNORE (DVID.EQ.1) ; CONC
IGNORE (DVID.EQ.2) ; PCA

$ESTIM MAX=9990 SIG=3 NOABORT ;PRINT=1
METHOD=ZERO LIKE
$COV

;O'REILLY RA, AGGELER PM. STUDIES ON COUMARIN ANTICOAGULANT DRUGS
;INITIATION OF WARFARIN THERAPY WITHOUT A LOADING DOSE.
;CIRCULATION 1968;38:169-177
;
;O'REILLY RA, AGGELER PM, LEONG LS. STUDIES OF THE COUMARIN ANTICOAGULANT
;DRUGS: THE PHARMACODYNAMICS OF WARFARIN IN MAN.
;JOURNAL OF CLINICAL INVESTIGATION 1963;42(10):1542-1551

;EVENT HAZARD
$THETA
(0,0.1,) ; POP_HBASE 1/Y BASELINE HAZARD (MAJOR HAEMORRHAGE) (0.1)
(0,0.5,) ; POP_BTAINR HAZARD RATIO INCREASE WITH INR (0.5)
$OMEGA 0 FIX ; PPV_HBASE (DUMMY TO KEEP NM-TRAN HAPPY)

$SUBR ADVAN6 TOL=3
$MODEL
   COMP=CENTRAL
   COMP=PCA
   COMP=HAZEVT

$PK

   IF (NEWIND.EQ.0) LN2=LOG(2)

   CL=ICL ;FSZCL*POP_CL*EXP(PPV_CL)*24 ; L/H -> L/D
   V=IV ;FSZV*POP_V*EXP(PPV_V)
   TABS=ITABS; POP_TABS*EXP(PPV_TABS)/24 ; H -> D
   TLAG=ITLAG; POP_LAG*EXP(PPV_LAG)/24 ; H -> D
   F1=IF1

   PCA0=IPCA0; POP_PCA0*EXP(PPV_PCA0)
   EMAX=IEMAX; POP_EMAX*EXP(PPV_EMAX)
   C50=IC50; POP_C50*EXP(PPV_C50)
   TEQ=ITEQ; POP_TEQ*EXP(PPV_TEQ)/24 ; H -> D

   HBASE=THETA(1)/365 *EXP(ETA(1)) ; 1/Y -> 1/D
   BTAINR=THETA(2) 

   D1=TABS
   ALAG1=TLAG
   S1=V
   A_0(2)=PCA0
   KPCA=LN2/TEQ
   RPCA=PCA0*KPCA
   
$DES
   DCP=A(1)/V
   DPCA=A(2)
   DINR=PCA0/DPCA
   PD=1+EMAX*DCP/(C50+DCP)
   DHAZ=HBASE*EXP(BTAINR*DINR)

   DADT(1)=- CL*DCP ; WARFARIN CONC
   DADT(2)=RPCA*PD - KPCA*DPCA ; TURNOVER FOR PCA
   DADT(3)=DHAZ

$ERROR

   CP=A(1)/V
   PCA=A(2)
   INR=PCA0/PCA
   CUMEVT=A(3)
   HAZ=HBASE*EXP(BTAINR*INR)

   ; PROB OF NOT HAVING EVENT UP TO THIS TIME
   SEVTT=EXP(-CUMEVT) ; SURVIVOR FUNCTION (T)

   IF (DVID.EQ.3.AND.DV.EQ.0) THEN 
      Y=SEVTT ; LIKELIHOOD OF CENSORED EVENT
   ENDIF
   IF (DVID.EQ.3.AND.DV.EQ.1) THEN 
      Y=SEVTT * HAZ ; LIKELIHOOD OF EVENT AT EXACT TIME
   ENDIF

