$PROB Estimate time to event
$INPUT ID TIME TRT 
AMT=DROP RATE=DROP ADDL=DROP II=DROP WT=DROP
DVID DV MDV REP=DROP
CPX=DROP PCAX=DROP INRX=DROP ; individual predictions of CP, PCA, INR
ICL=DROP IV=DROP ITABS=DROP ITLAG=DROP IF1=DROP ; individual PK parameters used for simulation
IPCA0=DROP IEMAX=DROP IC50=DROP ITEQ=DROP ; individual PD parameters used for simulation 

$DATA ..\warf_INR_sim.reg\1.csv  IGNORE=@
IGNORE (DVID.EQ.1) ; Conc
IGNORE (DVID.EQ.2) ; PCA

$ESTIM MAX=9990 SIG=3 NOABORT ;PRINT=1
METHOD=ZERO LIKE
$COV

;O'Reilly RA, Aggeler PM. Studies on coumarin anticoagulant drugs
;Initiation of warfarin therapy without a loading dose.
;Circulation 1968;38:169-177
;
;O'Reilly RA, Aggeler PM, Leong LS. Studies of the coumarin anticoagulant
;drugs: The pharmacodynamics of warfarin in man.
;Journal of Clinical Investigation 1963;42(10):1542-1551

;Event hazard
$THETA
(0,0.1,) ; POP_HBASE 1/y baseline hazard (major haemorrhage)
0.001 ; POP_BTAWBL hazard ratio increase per ln(year)
$OMEGA 0 FIX ; PPV_HBASE (dummy to keep NM-TRAN happy)

$SUBR ADVAN6 TOL=3
$MODEL
   COMP=CUMEVT

$PK
   HBASE=POP_HBASE/365 *EXP(PPV_HBASE) ; 1/y -> 1/d
   BTAWBL=POP_BTAWBL/365  ; 1/y -> 1/d

$DES
   IF (T.GT.0) THEN
      DHAZ=HBASE *EXP(BTAWBL*LOG(T))
   ELSE
      DHAZ=0
   ENDIF
   DADT(1)=DHAZ
$ERROR

   CUMEVT=A(1)
   IF (TIME.GT.0) THEN
      HAZ=HBASE *EXP(BTAWBL*LOG(TIME))
   ELSE
      HAZ=0
   ENDIF
   ; Prob of not having event up to this time
   SEVTT=EXP(-CUMEVT) ; Survivor function (t)

   IF (DVID.EQ.3.AND.DV.EQ.0) THEN 
      Y=SEVTT ; likelihood of censored event
   ENDIF
   IF (DVID.EQ.3.AND.DV.EQ.1) THEN 
      Y=SEVTT * HAZ ; likelihood of event at exact time
   ENDIF


